{

Project: Huffman.dpr
Current file: frmCode_unit.pas
Author: Poirot
E-Mail: poirot@rol.ru
Copyrights @ 20.05.2002

}

unit frmCode_unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Gauges, StdCtrls, ExtCtrls,
  unit_implement;

type
  TLetterCapacityThread = class (TThread)
  protected
   procedure Execute;override;
  end;

  TTreeBuildThread = class (TThread)
  protected
   procedure Execute;override;
  end;

  TTablTmpThread = class (TThread)
  protected
   procedure Execute;override;
  end;

  TFinalThread = class (TThread)//Temp to Binar File
  protected
   procedure Execute;override;
  end;

  TfrmCode = class(TForm)
    gHash: TGauge;
    stFileSize: TStaticText;
    lblHashState: TLabel;
    lblTreeState: TLabel;
    lblTablState: TLabel;
    gTabl: TGauge;
    butStart: TButton;
    OpenDialog: TOpenDialog;
    lblFile: TLabel;
    stFileName: TStaticText;
    lblFileSize: TLabel;
    lblHash: TLabel;
    lblTree: TLabel;
    lblTabl: TLabel;
    lblFinal: TLabel;
    lblFinalState: TLabel;
    gFinal: TGauge;
    bevHash: TBevel;
    bevTabl: TBevel;
    bevFinal: TBevel;
    bevStart: TBevel;
    procedure butStartClick(Sender: TObject);
   private
    procedure SubOnTerminate(Sender:TObject);
  end;

var
  frmCode: TfrmCode;
  FileName:TFileName='';
  lwFileSize:LongWord;
  ZeroOnemod8:Byte=0;
  CharCapHash:TCharCapHash;
  CurUnits:TCurUnits;
  Root:PhufElement;
  BinHash:TBinHash;

  //
  TLCT:TLetterCapacityThread;
  TTBT:TTreeBuildThread;
  TTTT:TTablTmpThread;
  TFT:TFinalThread;

implementation

uses frmStatus_unit;

{$R *.dfm}

procedure TLetterCapacityThread.Execute;
 var hTLCT:THandle;
     flRes:File;
     NumRead:Integer;
     Buf:Char;
 begin
  FreeOnTerminate:=True;
  hTLCT:=CreateMutex(nil,True,'TLCT');
  ClearCharCapHash(CharCapHash);
  AssignFile(flRes,FileName);
  {$I-}
  Reset(flRes,1);
  {$I+}
  if IOResult<>0 then raise EInOutError.Create('   ');

  lwFileSize:=FileSize(flRes);
  with frmCode do
   begin
    gHash.MaxValue:=lwFileSize;
    gHash.MinValue:=0;
    gHash.Progress:=0;
    stFileSize.Caption:=FormatFloat('###,###,###',lwFileSize);
    lblHashState.Caption:=States[2];
   end;

  NumRead:=0;
  repeat
   BlockRead(flRes,Buf, SizeOf(Buf), NumRead);
   if NumRead<>0 then
    begin
     Inc(CharCapHash[Buf]);
     with frmCode do
      gHash.Progress:=gHash.Progress+1;
    end;
  until NumRead=0;
  CloseFile(flRes);
  frmCode.lblHashState.Caption:=States[3];
  ReleaseMutex(hTLCT);
  CloseHandle(hTLCT);
end;

procedure TTreeBuildThread.Execute;
 var hTLCT, hTTBT:THandle;
     Len, Units:Word;//-  0 - ( )

 begin
  FreeOnTerminate:=True;

  hTTBT:=CreateMutex(nil,True,'TTBT');
  hTLCT:=OpenMutex(MUTEX_ALL_ACCESS,False,'TLCT');

  frmCode.lblTreeState.Caption:=States[1];
  WaitForSingleObject(hTLCT,INFINITE);

  frmCode.lblTreeState.Caption:=States[5];
  FillCurUnits(CurUnits,CharCapHash);

  Len:=Length(CurUnits);
  Units:=0;

  While true do
   begin
    if Len=1 then Break;
    Len:=BuildTreeFrom2Min(Len,CurUnits);

    Inc(Units);
    frmCode.lblTreeState.Caption:=Format(States[5],[Units]);
   end;

  Inc(Units);
  Root:=CurUnits[0];

  if Root^.Capacity<>lwFileSize then
   raise EreadError.Create('   ');

  ClearCurUnits(CurUnits);

  frmCode.lblTreeState.Caption:=States[3]+Format(' ( %d  )',[Units]);;
  ReleaseMutex(hTTBT);
  CloseHandle(hTTBT);
  CloseHandle(hTLCT);
 end;

procedure TTablTmpThread.Execute;
 var
  hTTBT, hTTTT:THandle;
  F_Res:File;
  F_Tar, F_Tmpl:TextFile;
  Buf:Char;
  NumRead:Integer;

 begin

  FreeOnTerminate:=True;

  hTTBT:=OpenMutex(MUTEX_ALL_ACCESS,False,'TTBT');
  hTTTT:=CreateMutex(nil,True,'TTTT');

  frmCode.lblTablState.Caption:=States[1];
  WaitForSingleObject(hTTBT,INFINITE);
  ClearBinHash(binHash);
  CreateTablOf(Root,'',BinHash);
  ClearHuffmanTree(Root);

  frmCode.gTabl.MaxValue:=lwFileSize;
  frmCode.gTabl.MinValue:=0;

  AssignFile(F_Res,FileName);
  AssignFile(F_Tar,FileName+'.huff.tmp');
  Reset(F_Res,1);
  Rewrite(F_Tar);

  NumRead:=0;
  repeat
   BlockRead(F_Res,Buf,SizeOf(Buf),NumRead);
   if NumRead<>0 then
    begin
     Write(F_Tar,BinHash[Buf]);
     frmCode.gTabl.Progress:=frmCode.gHash.Progress+1;
    end;
  until NumRead=0;

  ZeroOnemod8:=8-GetZeroOneZFileSize(BinHash,CharCapHash) mod 8;
  while ZeroOnemod8<>0 do
   begin
    Write(F_Tar,'0');
    Dec(ZeroOnemod8)
   end;
  CloseFile(F_Tar);
  CloseFile(F_Res);

  AssignFile(F_Tmpl,FileName+'.templ');
  Rewrite(F_Tmpl);
  WriteLn(F_Tmpl,'ResourceFileSize=',lwFileSize);
  Writeln(F_Tmpl,'8-01_FileSize_mod_8=',
   8-GetZeroOneZFileSize(BinHash,CharCapHash) mod 8);

  for Buf:=#0 to #255 do
  if CharCapHash[Buf]<>0 then
   Writeln(F_Tmpl,Ord(Buf),'=',CharCapHash[Buf]);
  CloseFile(F_Tmpl);

  frmCode.lblTablState.Caption:=States[3];
  ReleaseMutex(hTTTT);
  CloseHandle(hTTTT);
  CloseHandle(hTTBT);
 end;

procedure TFinalThread.Execute;
var hTTTT:THandle;
    F_Res, F_huf:File;
    NumRead, NotUsed: Integer;
    Buf:TBinarHashRecord;
    WriteBuf:Byte;

begin
 FreeOnTerminate:=True;

 hTTTT:=OpenMutex(MUTEX_ALL_ACCESS,False,'TTTT');
 frmCode.lblFinalState.Caption:=States[1];
 WaitForSingleObject(hTTTT,INFINITE);
 frmCode.lblFinalState.Caption:=States[2];
 AssignFile(F_Res,FileName+'.huff.tmp');
 AssignFile(F_huf,FileName+'.huff');
 Reset(F_Res,1);
 Rewrite(F_huf,1);

 NumRead:=0;
 NotUsed:=1;
 frmCode.gFinal.MaxValue:=FileSize(F_Res) div 8;
 repeat
  BlockRead(F_Res,Buf,SizeOf(Buf),NumRead);
  if NumRead<>0 then
   begin
    WriteBuf:=Get01toChar(Buf);
    BlockWrite(F_huf,WriteBuf,NotUsed);
    with frmCode.gFinal do
      Progress:=Progress+1;
   end;

 until NumRead=0;

 CloseFile(F_huf);
 CloseFile(F_Res);
 Erase(F_Res);
 frmCode.lblFinalState.Caption:=States[3];
 frmCode.butStart.Enabled:=true;
 CloseHandle(hTTTT);
 frmCode.Close;
end;

procedure TfrmCode.SubOnTerminate(Sender:TObject);
var
 HufFS:Longword;
begin
 HufFS:=gFinal.MaxValue;
 with frmStatus do
  begin
   stHufFileSize.Caption:=FormatFloat('###,###,###',HufFS);
   stFileSize.Caption:=FormatFloat('###,###,###',lwFileSize);
   stRatio.Caption:=FormatFloat('###.00%',HufFS * 100 / lwFileSize);
   gStatus.MaxValue:=lwFileSize;
   gStatus.Progress:=HufFS;
   ShowModal;
  end;
 Close;
end;

procedure TfrmCode.butStartClick(Sender: TObject);
begin
if OpenDialog.Execute then
  if (not FileExists(OpenDialog.FileName)) or (OpenDialog.FileName='') then
    raise EInOutError.Create('   /    ')
  else
   begin
    butStart.Enabled:=False;
    FileName:=OpenDialog.FileName;
    stFileName.Caption:=FileName;

    TLCT:=TLetterCapacityThread.Create(true);
    lblHashState.Caption:=Format(States[7],[TLCT.ClassName]);

    TTBT:=TTreeBuildThread.Create(true);
    lblTreeState.Caption:=Format(States[7],[TTBT.ClassName]);

    TTTT:=TTablTmpThread.Create(true);
    lblTablState.Caption:=Format(States[7],[TTTT.ClassName]);

    TFT:=TFinalThread.Create(true);
    TFT.OnTerminate:=SubOnTerminate;
    lblFinalState.Caption:=Format(States[7],[TFT.ClassName]);

    TTBT.Resume;
    TLCT.Resume;
    TTTT.Resume;
    TFT.Resume;

 end;

end;

end.
